/******************************************************************************
 * Product: Compiere ERP & CRM Smart Business Solution                        *
 * Copyright (C) 1999-2007 ComPiere, Inc. All Rights Reserved.                *
 * This program is free software, you can redistribute it and/or modify it    *
 * under the terms version 2 of the GNU General Public License as published   *
 * by the Free Software Foundation. This program is distributed in the hope   *
 * that it will be useful, but WITHOUT ANY WARRANTY, without even the implied *
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.           *
 * See the GNU General Public License for more details.                       *
 * You should have received a copy of the GNU General Public License along    *
 * with this program, if not, write to the Free Software Foundation, Inc.,    *
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.                     *
 * For the text or an alternative of this public license, you may reach us    *
 * ComPiere, Inc., 3600 Bridge Parkway #102, Redwood City, CA 94065, USA      *
 * or via info@compiere.org or http://www.compiere.org/license.html           *
 *****************************************************************************/
package org.compiere.model;

/** Generated Model - DO NOT CHANGE */
import java.sql.*;
import java.math.*;
import org.compiere.framework.*;
import org.compiere.util.*;
/** Generated Model for R_Source
 *  @author Jorg Janke (generated) 
 *  @version Release 3.0.0 - $Id: GenerateModel.java,v 1.1 2008/01/16 07:34:32 jrmt Exp $ */
public class X_R_Source extends PO
{
/** Standard Constructor
@param ctx context
@param R_Source_ID id
@param trxName transaction
*/
public X_R_Source (Ctx ctx, int R_Source_ID, String trxName)
{
super (ctx, R_Source_ID, trxName);
/** if (R_Source_ID == 0)
{
setName (null);
setR_Source_ID (0);
setSourceCreateType (null);	// L
setValue (null);
}
 */
}
/** Load Constructor 
@param ctx context
@param rs result set 
@param trxName transaction
*/
public X_R_Source (Ctx ctx, ResultSet rs, String trxName)
{
super (ctx, rs, trxName);
}
/** Serial Version No */
static final long serialVersionUID = 27462258115789L;
/** Last Updated Timestamp 2007-05-26 07:39:59.0 */
public static final long updatedMS = 1180132799000L;
/** AD_Table_ID=914 */
public static final int Table_ID=914;

/** TableName=R_Source */
public static final String Table_Name="R_Source";

protected static KeyNamePair Model = new KeyNamePair(914,"R_Source");

protected BigDecimal accessLevel = new BigDecimal(6);
/** AccessLevel
@return 6 - System - Client 
*/
protected int get_AccessLevel()
{
return accessLevel.intValue();
}
/** Load Meta Data
@param ctx context
@return PO Info
*/
protected POInfo initPO (Ctx ctx)
{
POInfo poi = POInfo.getPOInfo (ctx, Table_ID);
return poi;
}
/** Info
@return info
*/
public String toString()
{
StringBuffer sb = new StringBuffer ("X_R_Source[").append(get_ID()).append("]");
return sb.toString();
}
/** Set Description.
@param Description Optional short description of the record */
public void setDescription (String Description)
{
if (Description != null && Description.length() > 255)
{
log.warning("Length > 255 - truncated");
Description = Description.substring(0,255);
}
set_Value ("Description", Description);
}
/** Get Description.
@return Optional short description of the record */
public String getDescription() 
{
return (String)get_Value("Description");
}
/** Set Comment.
@param Help Comment, Help or Hint */
public void setHelp (String Help)
{
if (Help != null && Help.length() > 2000)
{
log.warning("Length > 2000 - truncated");
Help = Help.substring(0,2000);
}
set_Value ("Help", Help);
}
/** Get Comment.
@return Comment, Help or Hint */
public String getHelp() 
{
return (String)get_Value("Help");
}
/** Set Name.
@param Name Alphanumeric identifier of the entity */
public void setName (String Name)
{
if (Name == null) throw new IllegalArgumentException ("Name is mandatory.");
if (Name.length() > 120)
{
log.warning("Length > 120 - truncated");
Name = Name.substring(0,120);
}
set_Value ("Name", Name);
}
/** Get Name.
@return Alphanumeric identifier of the entity */
public String getName() 
{
return (String)get_Value("Name");
}
/** Get Record ID/ColumnName
@return ID/ColumnName pair */
public KeyNamePair getKeyNamePair() 
{
return new KeyNamePair(get_ID(), getName());
}
/** Set Source.
@param R_Source_ID Source for the Lead or Request */
public void setR_Source_ID (int R_Source_ID)
{
if (R_Source_ID < 1) throw new IllegalArgumentException ("R_Source_ID is mandatory.");
set_ValueNoCheck ("R_Source_ID", new Integer(R_Source_ID));
}
/** Get Source.
@return Source for the Lead or Request */
public int getR_Source_ID() 
{
Integer ii = (Integer)get_Value("R_Source_ID");
if (ii == null) return 0;
return ii.intValue();
}

/** SourceCreateType AD_Reference_ID=423 */
public static final int SOURCECREATETYPE_AD_Reference_ID=423;
/** Both = B */
public static final String SOURCECREATETYPE_Both = "B";
/** Lead = L */
public static final String SOURCECREATETYPE_Lead = "L";
/** Request = R */
public static final String SOURCECREATETYPE_Request = "R";
/** Is test a valid value.
@param test testvalue
@returns true if valid **/
public boolean isSourceCreateTypeValid (String test)
{
return test.equals("B") || test.equals("L") || test.equals("R");
}
/** Set Create Type.
@param SourceCreateType Automatically create Lead or Source */
public void setSourceCreateType (String SourceCreateType)
{
if (SourceCreateType == null) throw new IllegalArgumentException ("SourceCreateType is mandatory");
if (!isSourceCreateTypeValid(SourceCreateType))
throw new IllegalArgumentException ("SourceCreateType Invalid value - " + SourceCreateType + " - Reference_ID=423 - B - L - R");
if (SourceCreateType.length() > 1)
{
log.warning("Length > 1 - truncated");
SourceCreateType = SourceCreateType.substring(0,1);
}
set_Value ("SourceCreateType", SourceCreateType);
}
/** Get Create Type.
@return Automatically create Lead or Source */
public String getSourceCreateType() 
{
return (String)get_Value("SourceCreateType");
}
/** Set Search Key.
@param Value Search key for the record in the format required - must be unique */
public void setValue (String Value)
{
if (Value == null) throw new IllegalArgumentException ("Value is mandatory.");
if (Value.length() > 40)
{
log.warning("Length > 40 - truncated");
Value = Value.substring(0,40);
}
set_Value ("Value", Value);
}
/** Get Search Key.
@return Search key for the record in the format required - must be unique */
public String getValue() 
{
return (String)get_Value("Value");
}
}
